'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator;

function _load_regenerator() {
  return _regenerator = _interopRequireDefault(require('babel-runtime/regenerator'));
}

var _bluebird;

function _load_bluebird() {
  return _bluebird = require('bluebird');
}

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _fsExtra;

function _load_fsExtra() {
  return _fsExtra = _interopRequireDefault(require('fs-extra'));
}

var _path;

function _load_path() {
  return _path = _interopRequireDefault(require('path'));
}

var _sources;

function _load_sources() {
  return _sources = require('../consumer/component/sources');
}

var _constants;

function _load_constants() {
  return _constants = require('../constants');
}

var _bitId;

function _load_bitId() {
  return _bitId = require('../bit-id');
}

var _logger;

function _load_logger() {
  return _logger = _interopRequireDefault(require('../logger/logger'));
}

var _validationError;

function _load_validationError() {
  return _validationError = _interopRequireDefault(require('../error/validation-error'));
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var LinkFile = function (_AbstractVinyl) {
  _inherits(LinkFile, _AbstractVinyl);

  function LinkFile() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, LinkFile);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = LinkFile.__proto__ || Object.getPrototypeOf(LinkFile)).call.apply(_ref, [this].concat(args))), _this), _this.override = false, _this.writeAutoGeneratedMessage = true, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(LinkFile, [{
    key: 'write',
    // needed for logging purposes

    // existing path where the link is pointing to (needed for logging purposes)
    value: function () {
      var _ref2 = (0, (_bluebird || _load_bluebird()).coroutine)( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee() {
        var stat, fileContent, data;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return this._getStatIfFileExists();

              case 2:
                stat = _context.sent;

                if (!stat) {
                  _context.next = 10;
                  break;
                }

                if (!stat.isSymbolicLink()) {
                  _context.next = 6;
                  break;
                }

                throw new (_validationError || _load_validationError()).default(`fatal: trying to write a link file into a symlink file at "${this.path}"`);

              case 6:
                if (this.override) {
                  _context.next = 10;
                  break;
                }

                fileContent = (_fsExtra || _load_fsExtra()).default.readFileSync(this.path).toString();

                if (fileContent.includes((_constants || _load_constants()).AUTO_GENERATED_STAMP)) {
                  _context.next = 10;
                  break;
                }

                return _context.abrupt('return', this.path);

              case 10:
                data = this.writeAutoGeneratedMessage ? (_constants || _load_constants()).AUTO_GENERATED_MSG + this.contents : this.contents;

                (_logger || _load_logger()).default.debug(`link-file.write, path ${this.path}`);
                _context.prev = 12;
                _context.next = 15;
                return (_fsExtra || _load_fsExtra()).default.outputFile(this.path, data);

              case 15:
                _context.next = 28;
                break;

              case 17:
                _context.prev = 17;
                _context.t0 = _context['catch'](12);

                if (!(_context.t0.code === 'EISDIR')) {
                  _context.next = 27;
                  break;
                }

                (_logger || _load_logger()).default.debug(`deleting a directory ${this.path} in order to write a link file with the same name`);
                _context.next = 23;
                return (_fsExtra || _load_fsExtra()).default.remove(this.path);

              case 23:
                _context.next = 25;
                return (_fsExtra || _load_fsExtra()).default.outputFile(this.path, data);

              case 25:
                _context.next = 28;
                break;

              case 27:
                throw _context.t0;

              case 28:
                return _context.abrupt('return', this.path);

              case 29:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this, [[12, 17]]);
      }));

      function write() {
        return _ref2.apply(this, arguments);
      }

      return write;
    }()
  }], [{
    key: 'load',
    value: function load(_ref3) {
      var filePath = _ref3.filePath,
          base = _ref3.base,
          content = _ref3.content,
          _ref3$override = _ref3.override,
          override = _ref3$override === undefined ? false : _ref3$override,
          _ref3$writeAutoGenera = _ref3.writeAutoGeneratedMessage,
          writeAutoGeneratedMessage = _ref3$writeAutoGenera === undefined ? true : _ref3$writeAutoGenera,
          srcPath = _ref3.srcPath,
          componentId = _ref3.componentId;

      var linkFile = new LinkFile({
        base: base || (_path || _load_path()).default.dirname(filePath),
        path: filePath,
        contents: Buffer.from(content)
      });
      linkFile.override = override;
      linkFile.writeAutoGeneratedMessage = writeAutoGeneratedMessage;
      linkFile.srcPath = srcPath;
      linkFile.componentId = componentId;
      return linkFile;
    }
  }]);

  return LinkFile;
}((_sources || _load_sources()).AbstractVinyl);

exports.default = LinkFile;